unit FormSynEditor;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.Buttons, Vcl.Menus, Vcl.ImgList;

type
  TFormSynopticEditor = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabUsual: TTabSheet;
    ListBoxUsual: TListBox;
    TabWindows: TTabSheet;
    ListBoxWindows: TListBox;
    TabCharts: TTabSheet;
    ListBoxCharts: TListBox;
    SpeedBtnEdit: TSpeedButton;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrerlafiche: TMenuItem;
    Enregistrerlafichesous: TMenuItem;
    N11: TMenuItem;
    Importer1: TMenuItem;
    Exportervers1: TMenuItem;
    MenuFileSeparator: TMenuItem;
    MenuFile1: TMenuItem;
    MenuFile2: TMenuItem;
    MenuFile3: TMenuItem;
    MenuFile4: TMenuItem;
    MenuFile5: TMenuItem;
    MenuFile6: TMenuItem;
    MenuFile7: TMenuItem;
    MenuFile8: TMenuItem;
    MenuFile9: TMenuItem;
    MenuFile10: TMenuItem;
    Edition1: TMenuItem;
    Annuler1: TMenuItem;
    AlignerGrille1: TMenuItem;
    Mettree1: TMenuItem;
    Mettreenarrireplan1: TMenuItem;
    N4: TMenuItem;
    Aligner1: TMenuItem;
    Taille1: TMenuItem;
    Options2: TMenuItem;
    N5: TMenuItem;
    Rechercher1: TMenuItem;
    N12: TMenuItem;
    Couper2: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    Colleravecliaison1: TMenuItem;
    Supprimer1: TMenuItem;
    InsererobjetOLE1: TMenuItem;
    N6: TMenuItem;
    Proprits1: TMenuItem;
    Paramtres1: TMenuItem;
    Paramtresdelafentre1: TMenuItem;
    N14: TMenuItem;
    Terminerldition1: TMenuItem;
    N8: TMenuItem;
    Objet1: TMenuItem;
    SpeedButton1: TSpeedButton;
    ImageListUsual: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure ListBoxUsualDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedBtnEditClick(Sender: TObject);
    procedure ListBoxUsualDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure ListBoxUsualEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations prives }
    Function SaveTheForm: Boolean;
    Function SaveTheFormAs: Boolean;
  public
    { Dclarations publiques }
    IsTemplate : boolean;
    Procedure EditionForm;
    Function TerminateEdition: Boolean;
    Function ShowEditorTools(Showit: Boolean): Boolean;
  end;

var
  FormSynopticEditor: TFormSynopticEditor;

implementation

{$R *.dfm}
const
  LGName = 'FSynEditor';

procedure GradVertical(Canvas:TCanvas; Rect:TRect; FromColor, ToColor:TColor) ;
 var
   y,deltaY  : integer;
   dr,dg,db  : int64;
   r1,r2,g1,g2,b1,b2:Byte;
   R,G,B:Byte;
   cnt:integer;
 begin
   deltaY := Rect.Bottom-Rect.Top;
   if (deltaY<2) then exit;
   if (Rect.Right-Rect.Left)<2 then exit;

   R1 := GetRValue(FromColor) ;
   G1 := GetGValue(FromColor) ;
   B1 := GetBValue(FromColor) ;

   R2 := GetRValue(ToColor) ;
   G2 := GetGValue(ToColor) ;
   B2 := GetBValue(ToColor) ;

   dr := (R2-R1);
   dg := (G2-G1);
   db := (B2-B1);

   cnt := 0;
   for Y := Rect.Top to Rect.Bottom-1  do
   begin
     R := R1 + ((dr * cnt) div deltaY);
     G := G1 + ((dg * cnt) div deltaY);
     B := B1 + ((db * cnt) div deltaY);

     Canvas.Pen.Color := RGB(R,G,B) ;

     Canvas.MoveTo(Rect.Left,Y) ;
     Canvas.LineTo(Rect.Right,Y) ;
     inc(cnt) ;
   end;
 end;
 //-----------------------------------------------------------------------------------------------------
 // Draw a Horizontal gradient (degrade)
 //-----------------------------------------------------------------------------------------------------
 procedure GradHorizontal(Canvas:TCanvas; Rect:TRect; FromColor, ToColor:TColor) ;
 var
   x,deltaX  : integer;
   dr,dg,db  : int64;
   r1,r2,g1,g2,b1,b2:Byte;
   R,G,B:Byte;
   cnt:integer;
 begin
   deltaX := Rect.Right-Rect.Left;
   if (deltaX<2) then exit;
   if (Rect.Bottom-Rect.top)<2 then exit;

   R1 := GetRValue(FromColor) ;
   G1 := GetGValue(FromColor) ;
   B1 := GetBValue(FromColor) ;

   R2 := GetRValue(ToColor) ;
   G2 := GetGValue(ToColor) ;
   B2 := GetBValue(ToColor) ;

   dr := (R2-R1);
   dg := (G2-G1);
   db := (B2-B1);

   cnt := 0;
   for X := Rect.Left to Rect.Right  do
   begin
     R := R1 + ((dr * cnt) div deltaX);
     G := G1 + ((dg * cnt) div deltaX);
     B := B1 + ((db * cnt) div deltaX);

     Canvas.Pen.Color := RGB(R,G,B) ;

     Canvas.MoveTo(X,Rect.Top) ;
     Canvas.LineTo(X,Rect.Bottom) ;
     inc(cnt) ;
   end;
 end;
 //-----------------------------------------------------------------------------------------------------
 procedure LB_DrawItem(LB:TListBox;Index: Integer;Rect: TRect; State: TOwnerDrawState);
begin
    // Selected line
    if (odSelected in state)then
    begin
      Gradhorizontal(Lb.Canvas,rect,$00906040,clwhite); // ==> NON ! PLANTE du systme
    end else
    // Not selected line
    Begin
      Gradhorizontal(Lb.Canvas,rect,RGB(203,225,252),RGB(125,165,224));
    End;
end;

 //----------------------------------------------------------------------------------------------------------------------
procedure TFormSynopticEditor.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
  FormSynopticEditor:=nil;
end;
// -----------------------------------------------------------------------------------
procedure TFormSynopticEditor.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    CanClose := TerminateEdition;
end;
// -----------------------------------------------------------------------------------
procedure TFormSynopticEditor.FormCreate(Sender: TObject);
begin
  IsTemplate :=false;
end;
// -----------------------------------------------------------------------------------
procedure TFormSynopticEditor.ListBoxUsualDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
begin
  Accept:= false;
end;
// -----------------------------------------------------------------------------------
procedure TFormSynopticEditor.ListBoxUsualDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  LB_DrawItem(ListBoxUsual,index,rect,state);
end;
// -----------------------------------------------------------------------------------
procedure TFormSynopticEditor.ListBoxUsualEndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  ShowMessage('End drag');
end;

// -----------------------------------------------------------------------------------
Function TFormSynopticEditor.SaveTheForm: Boolean;
Begin
  ShowMessage('Save');
end;
// ----------------------------------------------------------------------------
Function TFormSynopticEditor.SaveTheFormAs: Boolean;
Begin
  ShowMessage('Save as');
End;
//----------------------------------------------------------------------------------------------------------------------
Procedure TFormSynopticEditor.EditionForm;
Begin
  ShowMessage('Edition');
End;
// ----------------------------------------------------------------------------
Function TFormSynopticEditor.TerminateEdition: Boolean;
Begin
  ShowMessage('terminate edition');
  result := True;
End;
//----------------------------------------------------------------------------------------------------------------------
Function TFormSynopticEditor.ShowEditorTools(Showit: Boolean): Boolean;
Begin

End;
//----------------------------------------------------------------------------------------------------------------------
procedure TFormSynopticEditor.SpeedBtnEditClick(Sender: TObject);
begin
  TerminateEdition;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure TFormSynopticEditor.SpeedButton1Click(Sender: TObject);
begin
  ShowMessage('speedbutton');
end;

//----------------------------------------------------------------------------------------------------------------------
Initialization

FormSynopticEditor := nil;

end.

